-- 
-- Written by: Vincent LARK
--                           vincent.lark@gmail.com
--   
--   
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU Library General Public License
-- as published by the Free Software Foundation; either version 2 of
-- the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Library General Public License for more details.
-- 
-- You should have received a copy of the GNU Library General Public
-- License along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

deferred class AUDIOFILE
-- This class is the AUDIOFILE interface
-- provides basic operations for audio files.


	
-- Attributs private
feature {}

	file : BINARY_FILE_READ
			-- Representation of the file

	file_tools : FILE_TOOLS

	file_lenght_memory: INTEGER
	 -- Taille du fichier mmorise

	is_tag_present_memory : BOOLEAN
			-- Presence de tag mmorise
	
	tag_checked : BOOLEAN
	 -- On est oblig de faire 2 variables
	
feature
	
	path    : STRING 
	
	title   : STRING
	artist  : STRING
	album   : STRING
	annee   : INTEGER
   comment : STRING
   genre   : INTEGER
	  -- Position dans liste_genres

	
	make(location: STRING) is
	-- Constructeur
		require
			location /= Void
			not location.is_empty
		deferred
		ensure
			path /= Void
		end


	file_lenght : INTEGER is
	-- Taille du fichier
		require
			path /= Void
			not path.is_empty
		do
			if file_lenght_memory = 0 then
				file_lenght_memory := file_tools.size_of(path) + 1
			end
			Result := file_lenght_memory - 1
		ensure
			Result >= 0
		end

	
	is_tag_present : BOOLEAN is
	-- Ce fichier contient-il un tag ?
		do
			if tag_checked then
				Result := is_tag_present_memory
			else
				is_tag_present_memory := is_tag_present_real
				tag_checked := True
				Result := is_tag_present_memory
			end
		end

	
	is_tag_present_real : BOOLEAN is
	-- Fonction relle de recherche de
	-- tag. Elle n'est appelle qu'une seule fois.
		require
			file /= Void
		deferred
		end
	

	is_tag_present_and_not_empty : BOOLEAN is
	-- Retourne Vrai si le fichier
	-- contient un tag et que les tags
	-- artiste et title ne sont pas vides
		do
			Result := is_tag_present

			if Result then
				Result := Result and not title.is_empty
				Result := Result and not artist.is_empty
			end
		end -- End of is_tag_present_and_not_empty

	
end

