-- 
-- Written by: Vincent LARK
--                           vincent.lark@gmail.com
--   
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU Library General Public License
-- as published by the Free Software Foundation; either version 2 of
-- the License, or (at your option) any later version.
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Library General Public License for more details.
-- 
-- You should have received a copy of the GNU Library General Public
-- License along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

expanded class AUDIOUTILS
-- This class provides some tools
-- for manipulating audio files.


creation
	make

feature {NONE}

	basic_directory : BASIC_DIRECTORY
	-- Rpertoires (adapts au systeme)

	genres_list_memory : ARRAY[STRING]
	
	genres_list_real : ARRAY[STRING] is
	-- Fill the genres_list array
		do
			create Result.make(0, 0)
			Result.clear_count
			
			Result.add_last("Blues")
			Result.add_last("Classic Rock")
			Result.add_last("Country")
			Result.add_last("Dance")
			Result.add_last("Disco")
			Result.add_last("Funk")
			Result.add_last("Grunge")
			Result.add_last("Hip-Hop")
			Result.add_last("Jazz")
			Result.add_last("Metal")
			Result.add_last("New Age")
			Result.add_last("Oldies")
			Result.add_last("Other")
			Result.add_last("Pop")
			Result.add_last("R&B")
			Result.add_last("Rap")
			Result.add_last("Reggae")
			Result.add_last("Rock")
			Result.add_last("Techno")
			Result.add_last("Industrial")
			Result.add_last("Alternative")
			Result.add_last("Ska")
			Result.add_last("Death Metal")
			Result.add_last("Pranks")
			Result.add_last("Soundtrack")
			Result.add_last("Euro-Techno")
			Result.add_last("Ambient")
			Result.add_last("Trip-Hop")
			Result.add_last("Vocal")
			Result.add_last("Jazz+Funk")
			Result.add_last("Fusion")
			Result.add_last("Trance")
			Result.add_last("Classical")
			Result.add_last("Instrumental")
			Result.add_last("Acid")
			Result.add_last("House")
			Result.add_last("Game")
			Result.add_last("Sound Clip")
			Result.add_last("Gospel")
			Result.add_last("Noise")
			Result.add_last("AlternRock")
			Result.add_last("Bass")
			Result.add_last("Soul")
			Result.add_last("Punk")
			Result.add_last("Space")
			Result.add_last("Meditative")
			Result.add_last("Instrum. Pop")
			Result.add_last("Instrum. Rock")
			Result.add_last("Ethnic")
			Result.add_last("Gothic")
			Result.add_last("Darkwave")
			Result.add_last("Techno-Industrial")
			Result.add_last("Electronic")
			Result.add_last("Pop-Folk")
			Result.add_last("Eurodance")
			Result.add_last("Dream")
			Result.add_last("Southern Rock")
			Result.add_last("Comedy")
			Result.add_last("Cult")
			Result.add_last("Gangsta")
			Result.add_last("Top")
			Result.add_last("Christian Rap")
			Result.add_last("Pop/Funk")
			Result.add_last("Jungle")
			Result.add_last("Native American")
			Result.add_last("Cabaret")
			Result.add_last("New Wave")
			Result.add_last("Psychadelic")
			Result.add_last("Rave")
			Result.add_last("Showtunes")
			Result.add_last("Trailer")
			Result.add_last("Lo-Fi")
			Result.add_last("Tribal")
			Result.add_last("Acid Punk")
			Result.add_last("Acid Jazz")
			Result.add_last("Polka")
			Result.add_last("Retro")
			Result.add_last("Musical")
			Result.add_last("Rock & Roll")
			Result.add_last("Hard Rock")
			Result.add_last("Folk")
			Result.add_last("Folk-Rock")
			Result.add_last("National Folk")
			Result.add_last("Swing")
			Result.add_last("Fast Fusion")
			Result.add_last("Bebob")
			Result.add_last("Latin")
			Result.add_last("Revival")
			Result.add_last("Celtic")
			Result.add_last("Bluegrass")
			Result.add_last("Avantgarde")
			Result.add_last("Gothic Rock")
			Result.add_last("Prog. Rock")
			Result.add_last("Psychedel. Rock")
			Result.add_last("Symph. Rock")
			Result.add_last("Slow Rock")
			Result.add_last("Big Band")
			Result.add_last("Chorus")
			Result.add_last("Easy Listening")
			Result.add_last("Acoustic")
			Result.add_last("Humour")
			Result.add_last("Speech")
			Result.add_last("Chanson")
			Result.add_last("Opera")
			Result.add_last("Chamber Music")
			Result.add_last("Sonata")
			Result.add_last("Symphony")
			Result.add_last("Booty Bass")
			Result.add_last("Primus")
			Result.add_last("Porn Groove")
			Result.add_last("Satire")
			Result.add_last("Slow Jam")
			Result.add_last("Club")
			Result.add_last("Tango")
			Result.add_last("Samba")
			Result.add_last("Folklore")
			Result.add_last("Ballad")
			Result.add_last("Power Ballad")
			Result.add_last("Rhythmic Soul")
			Result.add_last("Freestyle")
			Result.add_last("Duet")
			Result.add_last("Punk Rock")
			Result.add_last("Drum Solo")
			Result.add_last("Acapella")
			Result.add_last("Euro-House")
			Result.add_last("Dance Hall")

			genres_list_memory := Result
			
		ensure
			genres_list_memory /= Void
			Result.count = 126
		end


	

feature {ANY}

	
	genres_list : ARRAY[STRING] is
	-- Liste des differents genres possibles
		do
			if genres_list_memory = Void then
				Result := genres_list_real
			else
				Result := genres_list_memory
			end
		end

	
	
	make is
	-- Constructeur AUDIOUTILS
		do

		end


	
	scan_for_audio_files(path : STRING ; recursive : BOOLEAN) : ARRAY[STRING] is
	-- Retourne un tableau de noms de fichiers
	-- ayant une extension connue.
		require
			path /= Void
			not path.is_empty
		local
			ptr_dir : INTEGER
			directory : DIRECTORY
			file_tools : FILE_TOOLS
			base_path, file : STRING

			-- Liste des differentes extensions de fichier possibles
			audio_factory : AUDIOFILE_FACTORY

		do
			-- Init directory variables
			create directory.make
			create basic_directory
			
			-- Init audio extensions
			create audio_factory.make


			create Result.make(0, 0)
			Result.clear_count
			
			if (basic_directory.valid_path(path)) then
				
				directory.scan(path)

				create file_tools
				create base_path.make_empty
				
				from ptr_dir := directory.lower
				until ptr_dir > directory.upper
				loop

					base_path.copy(path)
					
					file := directory.item(ptr_dir)
					
					-- On exclu les rpertoire . et ..
					if (not file.same_as(".") and not file.same_as("..")) then

						basic_directory.connect_to(base_path)
						
						--io.put_string(" connected to .")
						--io.put_string(base_path)
						--io.put_new_line
							
						if (basic_directory.is_connected) then
							
							basic_directory.compute_file_path_with(base_path, file)
							base_path := basic_directory.last_entry.twin
							
							if (file_tools.is_directory(base_path)
								 and recursive) then

								--io.put_string(base_path)
								--io.put_string(" entered.")
								--io.put_new_line
								
								basic_directory.read_entry
								basic_directory.disconnect

								Result.append_collection(scan_for_audio_files(base_path, recursive))
							end
							
							if (file_tools.is_file(base_path)) then
								if (not audio_factory.query(file_extension(base_path)).is_empty) then
									--io.put_string(base_path)
									--io.put_string(" added.")
									--io.put_new_line
									
									Result.add_last(base_path.twin)
								end
							end

							if (basic_directory.is_connected) then
								basic_directory.disconnect
							end

						end
					end
					
					ptr_dir := ptr_dir + 1
				end
				
			end
		end -- End scan_for_audio_files
	


	
	get_playlist_entries(path : STRING) : ARRAY[STRING] is
	-- Recupere un tableau de chemins de fichiers
		require
			path /= Void
		local
			line_buffer : STRING
			playlist_file : TEXT_FILE_READ
		do
			create Result.make(0, 0)
			Result.clear_count

			create playlist_file.make
			playlist_file.connect_to(path)

			if playlist_file.is_connected then
				
				from 
				until playlist_file.end_of_input
				loop
					playlist_file.read_line
					line_buffer := playlist_file.last_string

					line_buffer.right_adjust
					line_buffer.left_adjust

					if not line_buffer.is_empty then
						if not line_buffer.first.same_as('#') then
							
							if basic_directory.valid_path(line_buffer) then
								Result.add_last(line_buffer.twin)
							else
								io.put_string("Dans la playlist " + path)
								io.put_string(" : le fichier '" + line_buffer)
								io.put_string("' n'existe pas ou n'est pas lisible !")
								io.put_new_line
							end

						end
					end
					
				end -- end of playlist.is_connected
			else
				io.put_string("Le fichier de playlist indique n'existe pas ou n'est pas lisible !")
				io.put_new_line
			end

		end
	
	
	
	file_extension(path : STRING) : STRING is
	-- Retourne l'extension (les caractres aprs le dernier '.')
		require
			path /= Void
			not path.is_empty
		local
			ptr_path : INTEGER
		do
			ptr_path := path.last_index_of('.') + 1
			
			if (ptr_path /= 0) then
				Result := path.substring(ptr_path, path.count)
			else
				-- Le chemin ne contient pas de point
				Result := ""
			end

		end -- End file_extension



	
	random_generator : MIN_STAND is
		once
			create Result.make
		end


	timer : MICROSECOND_TIME is
		do
			Result.update
		end
	

	random_number(max : INTEGER) : INTEGER is
		local
		do
			random_generator.with_seed(timer.microsecond)

			random_generator.next
			Result := random_generator.last_integer(max) - 1
		end


	
end
